<?php 

/*
Plugin Name: Minimy - Premium WordPress Gallery
Version: 1.3
Plugin URI: http://rubenbristian.com/wp-plugins/minimy-gallery/
Description: Minimy is a premium jQuery gallery plugin with a minimalist and pixel perfect design. Featuring two types of thumbnails, an elegant lightbox, navigation controls and slideshow options, this is the perfect way to showcase your photos!
Author: Ruben Bristian
Author URI: http://rubenbristian.com/
*/

//adding the plugin menu
function mm_add_plugin_menu() {
	$kbadmin = add_menu_page('Minimy Gallery', 'Minimy Gallery', 9, 'minimy_admin', 'minimy_admin_function', '../wp-content/plugins/minimy/images/galleryIcon.png');
	
	add_action('admin_print_scripts-'.$kbadmin, 'mm_print_scripts');
	add_action('admin_print_styles-'.$kbadmin,  'mm_print_styles');
}    

//printing the scripts
function mm_print_scripts() {
	
	wp_enqueue_script('d23ry892','/wp-content/plugins/minimy/js/ui/jquery.ui.core.min.js',false,null);
	wp_enqueue_script('dcq32123q','/wp-content/plugins/minimy/js/ui/jquery.ui.widget.min.js',false,null);
	wp_enqueue_script('23dxsqe23xq','/wp-content/plugins/minimy/js/ui/jquery.ui.mouse.min.js',false,null);
	wp_enqueue_script('32xqe2qx3','/wp-content/plugins/minimy/js/ui/jquery.ui.sortable.min.js',false,null);
	
	wp_enqueue_script('xdb3h9e2','/wp-content/plugins/minimy/js/swfupload/swfupload.js',false,null);
	wp_enqueue_script('xe3qx','/wp-content/plugins/minimy/js/swfupload/jquery.swfupload.js',false,null);
	
	wp_enqueue_script('v4tvfdfds','/wp-content/plugins/minimy/js/jscolor/jscolor.js',false,null);
	wp_enqueue_script('vctefee','/wp-content/plugins/minimy/js/msgbox/jquery.msgbox.js',false,null);
	
	wp_register_script('9x23un9023', '/wp-content/plugins/minimy/js/minimy.admin.js',false,null, array('jquery','media-upload','thickbox'));
	wp_enqueue_script('9x23un9023');
	
	wp_enqueue_script('media-upload');
	wp_enqueue_script('thickbox');
	
}

//printing the styles
function mm_print_styles() {

	wp_enqueue_style('cmeriq309r','/wp-content/plugins/minimy/css/minimy.admin.css');
	wp_enqueue_style('23n092','/wp-content/plugins/minimy/css/jquery-ui-1.8.10.custom.css');
	wp_enqueue_style('3m6ryun6rebh','/wp-content/plugins/minimy/js/msgbox/jquery.msgbox.css');
	wp_enqueue_style('thickbox');
	
}

function minimy_admin_function() {
	include('admin/minimyAdmin.php');
}

function mm_add_ie_styles() {
	echo '<!--[if IE 7]>
				<style type="text/css">
					.minimy-scroll-next img, .minimy-scroll-prev img {
						padding-top:7px;
					}
					.minimy-gallery {
						padding-bottom:20px;
					}
					.minimy-gallery img {
						min-width:auto !important;
					}
				</style>
			<![endif]-->';
}

function mm_add_script_conditionally($posts) {

	if (empty($posts)) return $posts;
 
	$shortcode_found = false; 
	foreach ($posts as $post) {
		if (stripos($post->post_content, 'minimy')) {
			$shortcode_found = true;
			break;
		}
	}
 
	if ($shortcode_found) {
		//enque main scripts
		wp_enqueue_script('jquery');
		wp_enqueue_script('c0ry34d', plugin_dir_url( __FILE__ ).'js/minimy.min.js',false, null, true);
		wp_enqueue_style('x23h7e23d',plugin_dir_url( __FILE__ ).'css/minimy.css',true, null);
	}
 
	return $posts;
	
}

function add_minimy($params) {

    global $wpdb;
    $table = $wpdb->prefix."db_minimy";
	
	$id = $params['id'];
	$link = $params['link'];
	$text = $params['text'];
	
	$gallery = $wpdb->get_row("SELECT * FROM " .$table. " WHERE minimy='$id'", ARRAY_N);
	$skin = $wpdb->get_row("SELECT * FROM " .$table. " WHERE type='2'", ARRAY_N);
	$skin = explode(';', $skin[3]);
	
	$oWidth = $skin[2];
	$oThumbW = $skin[3];
	$oThumbH = $skin[4];
	$oThumbs = $skin[5];
	
	$lImages = explode(',', $gallery[4]);
	$mThumbs = explode(',', $gallery[5]);
	$nThumbs = explode(',', $gallery[6]);
	$options = explode(',', $gallery[7]);
	$titles = explode(',', $gallery[8]);
	$captions = explode(',', $gallery[9]);
	
	$id=$params['id'];
	$imgDef = plugin_dir_url( __FILE__ ).'images/';
	
	srand ((double) microtime()*1000000);
	$random=rand();

	sizeof($lImages)<=$oThumbs ? $options[0]='yes' : $options[0];

	$hiddenStyle='';
	$hiddenText='';
	if($link=='true'){
		$hiddenStyle = ' style="display:none"';
		$hiddenText = '<a class="minimy-a" data-gallery="gallery'.$random.'" href="#">'.$text.'</a>';
	}
	
	$galleryStructure=$hiddenText.'<div class="minimy-holder"'.$hiddenStyle.'>
		<div id="gallery'.$random.'" class="minimy-gallery';
		$options[0]=='yes' ? $galleryStructure .= ' show-all">' : $galleryStructure .= '">';
			$galleryStructure .= '<img class="minimy-icon" src="'.$imgDef.'/photo_icon1.png" alt="" />
			
				<ul class="removeHover">';
	
		for($i=0; $i<sizeof($lImages); $i++){
			
			$galleryStructure .= '<li data-thumb="'.urldecode($nThumbs[$i]).'"><a href="'.urldecode($lImages[$i]).'" class="minimy"><img src="'.urldecode($mThumbs[$i]).'" ';
			
			if($titles[$i]!=''){
				$galleryStructure .= 'title="'.urldecode($titles[$i]).'" ';
			};
			if($captions[$i]!=''){
				$galleryStructure .= 'alt="'.urldecode($captions[$i]).'" ';
			};
			
			$galleryStructure .= '/></a></li>';
			
		}
	
	$galleryStructure .= '</ul>
	
		<a href="#" class="minimy-scroll-next">Previous</a>
		<a href="#" class="minimy-scroll-prev">Next</a>
		
		<noscript>
			<style type="text/css">
				.minimy-gallery ul {
					clip:auto;
					left:0px;
					position:relative;
				}
				.minimy-scroll-next, .minimy-scroll-prev, .minimy-icon {
					display:none;
				}
			</style>
		</noscript>
		
		</div></div>';
		
	$galleryStructure .= '<script type="text/javascript">
		jQuery(document).ready(function(){ 
			jQuery("#gallery'.$random.'").minimy({
				slideshowEnabled:'; $options[1] == 'yes' ? $galleryStructure.='true' : $galleryStructure.='false';$galleryStructure.=',
				slideshowOn:'; $options[2] == 'yes' ? $galleryStructure.='true' : $galleryStructure.='false';$galleryStructure.=',
				slideshowTimer:'.$options[5].',
				thumbsEnabled:'; $options[3] == 'yes' ? $galleryStructure.='true' : $galleryStructure.='false';$galleryStructure.=',
				captionsEnabled:'; $options[4] == 'yes' ? $galleryStructure.='true' : $galleryStructure.='false';$galleryStructure.=',
				imageResize:'; $options[6] == 'yes' ? $galleryStructure.='true' : $galleryStructure.='false';
				$galleryStructure.='
			});
		});
	</script>';

	return $galleryStructure;
	
}


//function that creates the plugin database on activation
function db_minimy_install() {

	 global $wpdb;
    $table = $wpdb->prefix."db_minimy";

	if($wpdb->get_var("SHOW TABLES LIKE '$table'") != $table) {

		$structure = "CREATE TABLE $table (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			minimy bigint NOT NULL,
			type tinyint NOT NULL,
			skin text NOT NULL,
			images text NOT NULL,
			thumbs1 text NOT NULL,
			thumbs2 text NOT NULL,
			options text NOT NULL,
			titles text NOT NULL,
			descriptions text NOT NULL,
			UNIQUE KEY id (id)
			);";
		$wpdb->query($structure);
		
		$query = $wpdb->query("INSERT INTO $table (`id`, `type`, `skin`, `options`) VALUES (NULL, '2', 'Minimiy Skin;minimy.css;600;119;89;4;000000;CC2052;CC2052;181818;333333;F7F7F7;666666;252525;F7F7F7;CC2052;F7F7F7;3;CC2052;false', 'minimy.css');");

	}
	
	copy(plugin_dir_url( __FILE__ ).'images/originals/preloader.gif', plugin_dir_url( __FILE__ ).'images/preloader.gif');
	copy(plugin_dir_url( __FILE__ ).'css/minimy.original.css', plugin_dir_url( __FILE__ ).'css/minimy.css');
	
}

//function that removes the plugin database
function db_minimy_uninstall() {
	
	global $wpdb;
	$wpdb->query("DROP TABLE ".$wpdb->prefix."db_minimy");

}

//add actions, hooks, filters and other stuff
register_activation_hook(__FILE__,'db_minimy_install');
register_deactivation_hook( __FILE__, 'db_minimy_uninstall' );
add_action('admin_menu', 'mm_add_plugin_menu');
add_action('wp_head', 'mm_add_ie_styles');
add_filter('the_posts', 'mm_add_script_conditionally');
add_filter('widget_text', 'do_shortcode');
add_shortcode('minimy', 'add_minimy');

?>